<template>
    <div class="content__leftAnalitika">
        <div class="recharge animated fadeInUp">
            <div class="recharge-top">
                <p class="text-recharge">{{ $t('operations.filter.title') }}</p>
                <div class="box-link">
                    <a href="#" class="popol" :class="{'active-popol': type === current_type }" v-for="(label, type) in types" @click.prevent="setType(type)">
                        {{ label }}
                    </a>
                </div>
            </div>
            <div class="box-onePopol">
                <form action="#" method="GET" @submit.prevent="submit">
                    <div class="box-inputOne">
                        <label for="login">{{ $t('operations.filter.login') }}</label>
                        <div class="box-input">
                            <svg>
                                <use xlink:href="/img/sprite.svg#profile"/>
                            </svg>
                            <input type="text" id="login" name="login" v-model="filter.login">
                        </div>
                    </div>
                    <div class="box-inputOne">
                        <label for="min_amount">{{ $t('operations.filter.amount_min') }}</label>
                        <div class="box-input">
                            <svg>
                                <use xlink:href="/img/sprite.svg#coin-1"/>
                            </svg>
                            <input type="text" id='min_amount' name='min_amount' v-model="filter.min_amount">
                        </div>
                    </div>
                    <div class="box-inputOne">
                        <label for="max_amount">{{ $t('operations.filter.amount_max') }}</label>
                        <div class="box-input">
                            <svg>
                                <use xlink:href="/img/sprite.svg#coin-1"/>
                            </svg>
                            <input type="text" id='max_amount' name='max_amount' v-model="filter.max_amount">
                        </div>
                    </div>
                    <div class="box-inputOne">
                        <label for="transaction_id">{{ $t('operations.filter.transaction_id') }}</label>
                        <div class="box-input">
                            <svg>
                                <use xlink:href="/img/sprite.svg#bar-code"/>
                            </svg>
                            <input type="text" id='transaction_id' name='transaction_id' v-model="filter.transaction_id">
                        </div>
                    </div>
                    <div class="box-buttonClose">
                        <button class="search-btn" type="submit">
                            <svg>
                                <use xlink:href="/img/sprite.svg#magnifying-glass"/>
                            </svg>
                            {{ $t('ui.search') }}
                        </button>
                        <a href="#" @click.prevent="setDefault">
                            <svg class="cancelButton">
                                <use xlink:href="/img/sprite.svg#cancel-button"/>
                            </svg>
                        </a>
                    </div>
                </form>
            </div>
        </div>
        <div class="box-recharge--bottom">
            <div class="bottom-top">
                <div class="box-topElement animated fadeInLeft">
                    <svg>
                        <use xlink:href="/img/sprite.svg#coins"/>
                    </svg>
                    <p class="text-pBlue">{{ $t('operations.total_count') }} <span>{{ total }} {{ $t('ui.pieces') }}</span></p>
                </div>
                <div class="box-topElement animated fadeInRight">
                    <svg>
                        <use xlink:href="/img/sprite.svg#coins-1"/>
                    </svg>
                    <p class="text-pBlue">{{ $t('operations.total_amount') }} <span>{{ total_amount }}</span></p>
                </div>
            </div>
            <div class="box-filter">
                <p class="text-left wow fadeInLeft">
                    <svg>
                        <use xlink:href="/img/sprite.svg#charging-circle"/>
                    </svg>
                    {{ $t('operations.table.title') }}
                </p>
                <div class="box-linkFilter wow fadeInRight">
                    <a href="" class="link-filter" :class="{'link-filter--active': status === current_status}" v-for="(label, status) in statuses" @click.prevent="setStatus(status)">{{ label }} </a>
                </div>
            </div>
            <div class="box-table--head wow fadeInUp">
                <div class="table--head--left">
                    <p class="text-head">{{ $t('operations.table.date') }}</p>
                </div>
                <div class="table--head--right">
                    <p class="text-head">{{ $t('operations.table.login') }}</p>
                    <p class="text-head">{{ $t('operations.table.amount') }}</p>
                    <p class="text-head">{{ $t('operations.table.transaction_id') }}</p>
                    <p class="text-head">{{ $t('operations.table.payment_system') }}</p>
                    <p class="text-head">{{ $t('operations.table.status') }}</p>
                </div>
            </div>
            <operation :operation="operation" v-for="operation in operations" :key="operation.id" @reload="submit"/>
            <paginator
                :current-page="currentPage"
                :last-page="lastPage"
                :per-page="perPage"
                :items-count="total"
                @page-changed="setPage"
            />
        </div>
    </div>
</template>

<script>
    import _ from 'lodash';
    import { mapGetters } from 'vuex';
	import Currencies from './../currencies';

	export default {
		name: "Operations",
        props: ['paginator', 'count', 'type'],
        data(){
			return {
				currentPage: this.paginator.current_page,
				lastPage: this.paginator.last_page,
				perPage: this.paginator.per_page,
				total: this.paginator.total,
				page: 1,
				current_type: 'user_refill',
				current_status: 'all',
                operations: this.paginator.data || [],
				filter: {
					type: 'user_refill',
					status: '',
					login: '',
					min_amount: '',
					max_amount: '',
					transaction_id: '',
                },
                types: {
				    'user_refill' : 'Пополнение',
				    'user_withdraw' : 'Вывод',
                },
                statuses: {
				    'created' :     this.$t('operations.table.statuses.created'),
				    'success' :     this.$t('operations.table.statuses.success'),
				    'in_progress' : this.$t('operations.table.statuses.in_progress'),
				    'canceled' :    this.$t('operations.table.statuses.canceled'),
				    'rejected' :    this.$t('operations.table.statuses.rejected'),
				    'all' :         this.$t('operations.table.statuses.all'),
                },
				amounts: {}
            }
        },
        computed: {
		    ...mapGetters([
		        'axios'
            ]),
			total_amount(){
		    	console.log(Currencies);
				return Currencies.format(_.reduce(this.amounts, (sum, value, key) => {
					let id = Number.parseInt(key);
					let amount = Number.parseFloat(value);
					let currency = Currencies.getById(id);
					let amount_in_default = Number.parseFloat(Currencies.convertToDefault(amount, currency));
					console.log(amount_in_default);
					return sum + amount_in_default;
				}, 0))
			}
        },
        watch: {
		    current_type(type){
                if(_.has(this.types, type)){
                    this.filter.type = type;
                }else{
					this.current_type = 'user_refill';
					this.filter.type = 'user_refill';
                }
				this.submit();
            },
		    type(type){
                this.current_type = type;
                this.filter.type = type;
				this.submit();
            },
			current_status(status){
                if(_.has(this.statuses, status)){
                	if(status === 'all'){
						this.filter.status = '';
					}else{
						this.filter.status = status;
					}
                }else{
					this.current_status = 'all';
					this.filter.status = '';
                }
				this.submit();
            },
        },
        methods: {
			setDefault(){
				this.filter = {
					type: this.filter.type,
					status: '',
					login: '',
					min_amount: '',
					max_amount: '',
					transaction_id: '',
				};
				this.submit();
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
            setType(type){
                this.current_type = type;
            },
            setStatus(status){
                this.current_status = status;
            },
            submit(){
				let params = {
				    ...this.filter
                };
				if(this.page > 1){
					params.page = this.page;
                }
                this.axios
                    .get('operations', {
                        params : params
                    })
                    .then(data => data.data)
                    .then(data => {
                        console.log(data);
                        this.action = data.path;
                        this.currentPage = data.current_page;
                        this.lastPage = data.last_page;
                        this.perPage = data.per_page;
                        this.total = data.total;
                        this.operations = data.data;
                    });
				this.loadStats();
            },
			loadStats(){
				let params = {
					...this.filter
				};
				this.axios
					.get('operations/stats', {
						params : params
					})
					.then(({ data }) => {
						console.log(data);
						this.amounts = data.amounts;
					})
			}
        },
        created(){
			this.loadStats();
		    if(this.type){
		    	this.setType(this.type);
            }
        },
        components: {
			'operation': require('./Operation.vue').default
        }
	}
</script>

<style scoped>

</style>
